Index: trunk/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2528)
@@ -6,8 +6,4 @@
    !! History :   1.0  !  2004-03  (C. Ethe)  original code
    !!             2.0  !  2007-12 (C. Ethe, G. Madec)  rewritting
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0,  LOCEAN-IPSL (2007)
-   !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -32,9 +28,15 @@
    USE par_oce , ONLY :   jpkdta   =>   jpkdta     !: number of levels            > or = jpk
    USE par_oce , ONLY :   lk_esopa =>   lk_esopa   !: flag to activate the all option
+   USE par_oce , ONLY :   jp_tem   =>   jp_tem     !: indice for temperature
+   USE par_oce , ONLY :   jp_sal   =>   jp_sal     !: indice for salinity
 
    !* IO manager *
-   USE in_out_manager      ! use all the variables
+   USE in_out_manager    
+                          
    !* physical constants *
-   USE phycst              ! use all the variables
+   USE phycst            
+
+   !* 1D configuration
+   USE c1d                                         
 
    !* model domain *
@@ -111,17 +113,29 @@
    USE dom_oce , ONLY :   ln_sco     =>  ln_sco      !: s-coordinate flag
    USE dom_oce , ONLY :   ln_zco     =>  ln_zco      !: z-coordinate flag
-   USE dom_oce , ONLY :   lk_zco     =>  lk_zco      !: z-coordinate flag (1D or 3D arrays)
-   USE dom_oce , ONLY :   hbatt      =>   hbatt      !: ocean depth at the vertical of  t-point (m)
-   USE dom_oce , ONLY :   hbatu      =>   hbatu      !: ocean depth at the vertical of  u-point (m)
-   USE dom_oce , ONLY :   hbatv      =>   hbatv      !: ocean depth at the vertical of w-point (m)
-   USE dom_oce , ONLY :   gsigt      =>   gsigt      !: model level depth coefficient at T-levels
-   USE dom_oce , ONLY :   gsigw      =>   gsigw      !: model level depth coefficient at W-levels
-   USE dom_oce , ONLY :   gsi3w      =>   gsi3w      !: model level depth coef at w-levels (defined as the sum of e3w)
-   USE dom_oce , ONLY :   esigt      =>   esigt      !: vertical scale factor coef. at t-levels
-   USE dom_oce , ONLY :   esigw      =>   esigw      !: vertical scale factor coef. at w-levels
-   USE dom_oce , ONLY :   lk_vvl     => lk_vvl       !: variable grid flag
-
+   USE dom_oce , ONLY :   hbatt      =>  hbatt       !: ocean depth at the vertical of  t-point (m)
+   USE dom_oce , ONLY :   hbatu      =>  hbatu       !: ocean depth at the vertical of  u-point (m)
+   USE dom_oce , ONLY :   hbatv      =>  hbatv       !: ocean depth at the vertical of w-point (m)
+   USE dom_oce , ONLY :   gsigt      =>  gsigt       !: model level depth coefficient at T-levels
+   USE dom_oce , ONLY :   gsigw      =>  gsigw       !: model level depth coefficient at W-levels
+   USE dom_oce , ONLY :   gsi3w      =>  gsi3w       !: model level depth coef at w-levels (defined as the sum of e3w)
+   USE dom_oce , ONLY :   esigt      =>  esigt       !: vertical scale factor coef. at t-levels
+   USE dom_oce , ONLY :   esigw      =>  esigw       !: vertical scale factor coef. at w-levels
+   USE dom_oce , ONLY :   lk_vvl     =>  lk_vvl      !: variable grid flag
+# if defined key_vvl
+   USE dom_oce , ONLY :   gdep3w_1   =>  gdep3w_1    !: ???
+   USE dom_oce , ONLY :   gdept_1    =>  gdept_1     !: depth of t-points (m)
+   USE dom_oce , ONLY :   gdepw_1    =>  gdepw_1     !: depth of t-points (m)
+   USE dom_oce , ONLY :   e3t_1      =>  e3t_1       !: vertical scale factors at t-
+   USE dom_oce , ONLY :   e3u_1      =>  e3u_1       !: vertical scale factors at u-
+   USE dom_oce , ONLY :   e3v_1      =>  e3v_1       !: vertical scale factors v-
+   USE dom_oce , ONLY :   e3w_1      =>  e3w_1       !: w-points (m)
+   USE dom_oce , ONLY :   e3f_1      =>  e3f_1       !: f-points (m)
+   USE dom_oce , ONLY :   e3uw_1     =>  e3uw_1      !: uw-points (m)
+   USE dom_oce , ONLY :   e3vw_1     =>  e3vw_1      !: vw-points (m)
+# endif
    !* masks, bathymetry *
-   USE dom_oce , ONLY :   mbathy     =>   mbathy     !: number of ocean level (=0,  & 1, ... , jpk-1) 
+   USE dom_oce , ONLY :   mbkt       =>   mbkt       !: vertical index of the bottom last T- ocean level
+   USE dom_oce , ONLY :   mbku       =>   mbku       !: vertical index of the bottom last U- ocean level
+   USE dom_oce , ONLY :   mbkv       =>   mbkv       !: vertical index of the bottom last V- ocean level
    USE dom_oce , ONLY :   tmask_i    =>   tmask_i    !: Interior mask at t-points
    USE dom_oce , ONLY :   tmask      =>   tmask      !: land/ocean mask at t-points
@@ -129,7 +143,4 @@
    USE dom_oce , ONLY :   vmask      =>   vmask      !: land/ocean mask at v-points 
    USE dom_oce , ONLY :   fmask      =>   fmask      !: land/ocean mask at f-points 
-# if defined key_off_degrad
-   USE dom_oce , ONLY :   facvol     =>   facvol     !: volume factor for degradation
-# endif
 
    !* time domain *
@@ -166,18 +177,24 @@
    USE oce , ONLY :   tn      =>    tn      !: pot. temperature (celsius)
    USE oce , ONLY :   sn      =>    sn      !: salinity (psu)
+   USE oce , ONLY :   tsn     =>    tsn     !: 4D array contaning ( tn, sn )
+   USE oce , ONLY :   tsb     =>    tsb     !: 4D array contaning ( tb, sb )
+   USE oce , ONLY :   tsa     =>    tsa     !: 4D array contaning ( ta, sa )
    USE oce , ONLY :   rhop    =>    rhop    !: potential volumic mass (kg m-3) 
    USE oce , ONLY :   rhd     =>    rhd     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
    USE oce , ONLY :   hdivn   =>    hdivn   !: horizontal divergence (1/s)
-#if defined key_off_tra
-   USE oce , ONLY :   gtu     =>    gtu     !: t-, s- and rd horizontal gradient at u- and
-   USE oce , ONLY :   gsu     =>    gsu     !: v-points at bottom ocean level
+   USE oce , ONLY :   l_traldf_rot => l_traldf_rot  !: rotated laplacian operator for lateral diffusion
+#if defined key_offline
+   USE oce , ONLY :   gtsu    =>    gtsu    !: t-, s- and rd horizontal gradient at u- and
+   USE oce , ONLY :   gtsv    =>    gtsv    !:
    USE oce , ONLY :   gru     =>    gru     !:
-   USE oce , ONLY :   gtv     =>    gtv     !:
-   USE oce , ONLY :   gsv     =>    gsv     !:
    USE oce , ONLY :   grv     =>    grv     !: 
+# if defined key_degrad
+   USE dommsk , ONLY :   facvol     =>   facvol     !: volume factor for degradation
+# endif
+
 #endif
-   USE lib_mpp , ONLY :   lk_mpp    =>  lk_mpp       !: Mpp flag
-
-   USE dom_oce , ONLY :   n_cla     =>   n_cla         !: flag (0/1) for cross land advection 
+   USE lib_mpp , ONLY :   lk_mpp    =>  lk_mpp        !: Mpp flag
+
+   USE dom_oce , ONLY :   nn_cla    =>  nn_cla        !: flag (0/1) for cross land advection 
 
    !* surface fluxes *
@@ -186,23 +203,17 @@
    USE sbc_oce , ONLY :   wndm       =>    wndm       !: 10m wind speed 
    USE sbc_oce , ONLY :   qsr        =>    qsr        !: penetrative solar radiation (w m-2)  
-   USE sbc_oce , ONLY :   emp        =>    emp        !: evaporation minus precipitation (kg m-2 s-2) 
-   USE sbc_oce , ONLY :   emps       =>    emps       !: evaporation minus precipitation (kg m-2 s-2)
+   USE sbc_oce , ONLY :   emp        =>    emp        !: freshwater budget: volume flux               [Kg/m2/s]
+   USE sbc_oce , ONLY :   emps       =>    emps       !: freshwater budget: concentration/dillution   [Kg/m2/s]
+   USE sbc_oce , ONLY :   rnf        =>    rnf        !: river runoff   [Kg/m2/s]
+   USE sbc_oce , ONLY :   ln_dm2dc   =>    ln_dm2dc   !: Daily mean to Diurnal Cycle short wave (qsr) 
+   USE sbc_oce , ONLY :   ln_rnf     =>    ln_rnf     !: runoffs / runoff mouths
    USE sbc_oce , ONLY :   fr_i       =>    fr_i       !: ice fraction (between 0 to 1)
    USE traqsr  , ONLY :   rn_abs     =>    rn_abs     !: fraction absorbed in the very near surface
    USE traqsr  , ONLY :   rn_si0     =>    rn_si0     !: very near surface depth of extinction
-   USE traqsr  , ONLY :   rn_si2     =>    rn_si2     !: deepest depth of extinction (blue &  0.01 mg.m-3)     (RGB)
    USE traqsr  , ONLY :   ln_qsr_bio =>    ln_qsr_bio !: flag to use or not the biological fluxes for light
    USE sbcrnf  , ONLY :   rnfmsk     =>    rnfmsk     !: mixed adv scheme in runoffs vicinity (hori.) 
    USE sbcrnf  , ONLY :   rnfmsk_z   =>    rnfmsk_z   !: mixed adv scheme in runoffs vicinity (vert.)
 
-   !* bottom boundary layer *
-# if   defined key_trabbl_dif   ||   defined key_trabbl_adv
-# if ! defined key_off_tra 
-   USE trabbl , ONLY :   atrbbl   =>   rn_ahtbbl     !: lateral coeff. for bottom boundary layer scheme (m2/s)
-# else 
-   USE trabbl, ONLY :   bblx   => bblx         !: ???
-   USE trabbl, ONLY :   bbly   => bbly         !: ???
-#  endif
-# endif
+   USE trc_oce
 
    !* lateral diffusivity (tracers) *
@@ -221,5 +232,5 @@
    USE zdf_oce , ONLY :   avt        =>   avt         !: vert. diffusivity coef. at w-point for temp  
 # if defined key_zdfddm
-   USE zdfddm  , ONLY :   avs        =>    avs        !: salinity vertical diffusivity coeff. at w-point
+   USE zdfddm  , ONLY :   avs        =>   avs        !: salinity vertical diffusivity coeff. at w-point
 # endif
 
@@ -245,4 +256,8 @@
 #endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE oce_trc
Index: trunk/NEMOGCM/NEMO/TOP_SRC/par_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/par_trc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/par_trc.F90	(revision 2528)
@@ -9,8 +9,4 @@
    !!             1.0  !  2004-03  (C. Ethe) Free form and module
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  revised architecture
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
    USE par_kind          ! kind parameters
@@ -39,37 +35,11 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_trc_c1d   = .FALSE.  !: 1D pass. tracer configuration flag
 # endif
-   ! Passive tracers : size for TRP trends diagnotics (used if 'key_trc_diatrd' defined)
-# if defined key_trc_diatrd
-   ! Passive tracers : size for TRP trends diagnotics (used if 'key_trc_diatrd' defined)
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_xad     =  1   !: x- horizontal advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_yad     =  2   !: y- horizontal advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_zad     =  3   !: z- vertical   advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_xdf     =  4   !: lateral       diffusion
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_ydf     =  5   !: lateral       diffusion
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_zdf     =  6   !: vertical diffusion (Kz)
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_sbc     =  7   !: surface boundary condition
-#if ! defined key_trcldf_eiv && ! defined key_trcdmp
-   INTEGER, PUBLIC,  PARAMETER ::   jpdiatrc      =  7  !: trends: 3*(advection + diffusion       ) + sbc
-#endif
-#if defined key_trcldf_eiv && defined key_trcdmp
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_xei     =  8   !: x- horiz. EIV advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_yei     =  9   !: y- horiz. EIV advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_zei     = 10   !: z- vert.  EIV advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_dmp     = 11   !: damping
-   INTEGER, PUBLIC,  PARAMETER ::   jpdiatrc      = 11   !: trends: 3*(advection + diffusion + eiv ) + sbc + damping
-#endif
-#if defined key_trcldf_eiv && ! defined key_trcdmp
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_xei     =  8   !: x- horiz. EIV advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_yei     =  9   !: y- horiz. EIV advection
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_zei     = 10   !: z- vert.  EIV advection
-   INTEGER, PUBLIC,  PARAMETER ::   jpdiatrc      = 10   !: trends: 3*(advection + diffusion + eiv ) + sbc 
-#endif
-#if ! defined key_trcldf_eiv && defined key_trcdmp
-   INTEGER, PUBLIC,  PARAMETER ::   jptrc_dmp     =  8   !: damping
-   INTEGER, PUBLIC,  PARAMETER ::   jpdiatrc      =  8   !: trends: 3*(advection + diffusion       ) + sbc + damping
-#endif
-#endif
 
    REAL(wp), PUBLIC  :: rtrn  = 1.e-15      !: truncation value     
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE par_trc
Index: trunk/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/prtctl_trc.F90	(revision 2528)
@@ -35,10 +35,4 @@
    PUBLIC prt_ctl_trc_info    !
    PUBLIC prt_ctl_trc_init    ! called by opa.F90
-
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
 
 CONTAINS
@@ -466,5 +460,9 @@
    !!----------------------------------------------------------------------
 #endif
-    
-   !!======================================================================
+ 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!======================================================================   
 END MODULE prtctl_trc
Index: trunk/NEMOGCM/NEMO/TOP_SRC/top_substitute.h90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/top_substitute.h90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/top_substitute.h90	(revision 2528)
@@ -2,79 +2,16 @@
    !!                    ***  top_substitute.h90   ***
    !!----------------------------------------------------------------------
-   !! ** purpose : Statement function file: to be include in all routines
-   !!              concerning passive tracer model 
+   !! ** purpose : Statement function file: to be include in all passive tracer modules
    !!----------------------------------------------------------------------
    !! History :   1.0  !  2004-03 (C. Ethe) Original code
    !!             2.0  !  2007-12 (C. Ethe, G. Madec) new architecture
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+#  include "domzgr_substitute.h90"
+#  include "ldfeiv_substitute.h90"
+#  include "ldftra_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
-    ! Lateral eddy diffusivity coefficient for passive tracer:
-    ! ========================================================
-#if defined key_traldf_c3d || defined key_off_degrad
-!   'key_traldf_c3d' :                 aht: 3D coefficient
-#       define fsahtrt(i,j,k)  trcrat * ahtt(i,j,k)
-#       define fsahtru(i,j,k)  trcrat * ahtu(i,j,k)
-#       define fsahtrv(i,j,k)  trcrat * ahtv(i,j,k)
-#       define fsahtrw(i,j,k)  trcrat * ahtw(i,j,k)
-#elif defined key_traldf_c2d
-!   'key_traldf_c2d' :                 aht: 2D coefficient
-#       define fsahtrt(i,j,k)  trcrat * ahtt(i,j)
-#       define fsahtru(i,j,k)  trcrat * ahtu(i,j)
-#       define fsahtrv(i,j,k)  trcrat * ahtv(i,j)
-#       define fsahtrw(i,j,k)  trcrat * ahtw(i,j)
-#elif defined key_traldf_c1d
-!   'key_traldf_c1d' :                 aht: 1D coefficient
-#       define fsahtrt(i,j,k)  trcrat * ahtt(k)
-#       define fsahtru(i,j,k)  trcrat * ahtu(k)
-#       define fsahtrv(i,j,k)  trcrat * ahtv(k)
-#       define fsahtrw(i,j,k)  trcrat * ahtw(k)
-#else
-!   Default option :             aht: Constant coefficient
-#       define fsahtrt(i,j,k)  ahtrc0
-#       define fsahtru(i,j,k)  ahtrc0
-#       define fsahtrv(i,j,k)  ahtrc0
-#       define fsahtrw(i,j,k)  ahtrc0
-#endif
-
-    ! Eddy induced velocity  coefficient for passive tracer:
-    ! ========================================================
-#if defined key_traldf_c3d || defined key_off_degrad
-!   'key_traldf_c3d' :                 eiv: 3D coefficient
-#       define fsaeitru(i,j,k)  trcrat * aeiu(i,j,k)
-#       define fsaeitrv(i,j,k)  trcrat * aeiv(i,j,k)
-#       define fsaeitrw(i,j,k)  trcrat * aeiw(i,j,k)
-#elif defined key_traldf_c2d
-!   'key_traldf_c2d' :                 eiv: 2D coefficient
-#       define fsaeitru(i,j,k)  trcrat * aeiu(i,j)
-#       define fsaeitrv(i,j,k)  trcrat * aeiv(i,j)
-#       define fsaeitrw(i,j,k)  trcrat * aeiw(i,j)
-#elif defined key_traldf_c1d
-!   'key_traldf_c1d' :                 eiv: 1D coefficient
-#       define fsaeitru(i,j,k)  trcrat * aeiu(k)
-#       define fsaeitrv(i,j,k)  trcrat * aeiv(k)
-#       define fsaeitrw(i,j,k)  trcrat * aeiw(k)
-#else
-!   Default option :             eiv: Constant coefficient
-#       define fsaeitru(i,j,k)  aeiv0
-#       define fsaeitrv(i,j,k)  aeiv0
-#       define fsaeitrw(i,j,k)  aeiv0
-#endif
-    ! mixing for passive tracer:
-    ! ========================================================
-#if defined key_trc_zdfddm
-!   'key_trc_zdfddm' :    avs 
-#       define fstravs(i,j,k)   avs(i,j,k)
-#else
-!   Defautl option :   avs = avt
-#       define fstravs(i,j,k)   avt(i,j,k)
-#endif
-
-! ========================================================
-#include "domzgr_substitute.h90"
-#include "ldfeiv_substitute.h90"
-#include "ldftra_substitute.h90"
-#include "vectopt_loop_substitute.h90"
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 2528)
@@ -4,12 +4,8 @@
    !! Passive tracers   :  module for tracers defined
    !!======================================================================
-   !! History :    -   !  1996-01  (M. Levy)  Original code
+   !! History :   OPA  !  1996-01  (M. Levy)  Original code
    !!              -   !  1999-07  (M. Levy)  for LOBSTER1 or NPZD model
    !!              -   !  2000-04  (O. Aumont, M.A. Foujols)  HAMOCC3 and P3ZD
-   !!             1.0  !  2004-03  (C. Ethe)  Free form and module
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!   NEMO      1.0  !  2004-03  (C. Ethe)  Free form and module
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -34,12 +30,11 @@
    INTEGER, PUBLIC                   ::   numnat   !: the number of the passive tracer NAMELIST
    LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutini   !:  initialisation from FILE or not (NAMELIST)
-   LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutsav   !:  logical for saving tracer or not
-   INTEGER, PUBLIC, DIMENSION(jptra) ::   nutini   !: FORTRAN LOGICAL UNIT for initialisation file
+   LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutsav   !:  save the tracer or not
 
    !! passive tracers fields (before,now,after)
    !! --------------------------------------------------
-   REAL(wp), PUBLIC ::   trai                         !: initial total tracer
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk) :: cvol  !: masked grid volume 
-   REAL(wp), PUBLIC ::   areatot                      !: total volume 
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk) :: cvol   !: volume correction -degrad option- 
+   REAL(wp), PUBLIC ::   trai                          !: initial total tracer
+   REAL(wp), PUBLIC ::   areatot                       !: total volume 
 
    REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   trn   !: traceur concentration for actual time step
@@ -47,47 +42,52 @@
    REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   trb   !: traceur concentration for before time step
 
+   !! interpolated gradient
+   !!--------------------------------------------------  
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtru   !: horizontal gradient at u-points at bottom ocean level
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtrv   !: horizontal gradient at v-points at bottom ocean level
    
    !! passive tracers restart (input and output)
    !! ------------------------------------------  
-   INTEGER , PUBLIC  ::  ndttrc     !: frequency of step on passive tracers
-   INTEGER , PUBLIC  ::  nittrc000  !: first time step of passive tracers model
-   LOGICAL , PUBLIC  ::  ln_rsttr     !: boolean term for restart i/o for passive tracers (namelist)
-   LOGICAL , PUBLIC  ::  lrst_trc   !: logical to control the trc restart write
-   INTEGER , PUBLIC  ::  nutwrs     !: output FILE for passive tracers restart
-   INTEGER , PUBLIC  ::  nutrst     !: logical unit for restart FILE for passive tracers
-   INTEGER , PUBLIC  ::  nrsttr     !: control of the time step ( 0 or 1 ) for pass. tr.
-   CHARACTER(len=50) ::  cn_trcrst_in  !: suffix of pass. tracer restart name (input)
-   CHARACTER(len=50) ::  cn_trcrst_out !: suffix of pass. tracer restart name (output)
+   LOGICAL , PUBLIC          ::  ln_rsttr      !: boolean term for restart i/o for passive tracers (namelist)
+   LOGICAL , PUBLIC          ::  lrst_trc      !: logical to control the trc restart write
+   INTEGER , PUBLIC          ::  nn_dttrc      !: frequency of step on passive tracers
+   INTEGER , PUBLIC          ::  nutwrs        !: output FILE for passive tracers restart
+   INTEGER , PUBLIC          ::  nutrst        !: logical unit for restart FILE for passive tracers
+   INTEGER , PUBLIC          ::  nn_rsttr      !: control of the time step ( 0 or 1 ) for pass. tr.
+   CHARACTER(len=50), PUBLIC ::  cn_trcrst_in  !: suffix of pass. tracer restart name (input)
+   CHARACTER(len=50), PUBLIC ::  cn_trcrst_out !: suffix of pass. tracer restart name (output)
    
    !! information for outputs
    !! --------------------------------------------------
-   INTEGER , PUBLIC ::   nwritetrc   !: time step frequency for concentration outputs (namelist)
+   INTEGER , PUBLIC ::   nn_writetrc   !: time step frequency for concentration outputs (namelist)
+   REAL(wp), PUBLIC, DIMENSION(jpk) ::   rdttrc        !: vertical profile of passive tracer time step
    
-# if defined key_trc_diaadd && ! defined key_iomput
+# if defined key_diatrc && ! defined key_iomput
    !! additional 2D/3D outputs namelist
    !! --------------------------------------------------
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2d   !: 2d output field name
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2u   !: 2d output field unit   
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3d   !: 3d output field name
-   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3u   !: 3d output field unit
-   CHARACTER(len=80), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2l   !: 2d output field long name
-   CHARACTER(len=80), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3l   !: 3d output field long name
+   INTEGER , PUBLIC                               ::   nwritedia   !: frequency of additional arrays outputs(namelist)
+   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2d      !: 2d output field name
+   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2u      !: 2d output field unit   
+   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3d      !: 3d output field name
+   CHARACTER(len= 8), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3u      !: 3d output field unit
+   CHARACTER(len=80), PUBLIC, DIMENSION (jpdia2d) ::   ctrc2l      !: 2d output field long name
+   CHARACTER(len=80), PUBLIC, DIMENSION (jpdia3d) ::   ctrc3l      !: 3d output field long name
 
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,    jpdia2d) ::   trc2d   !:  additional 2d outputs  
-   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jpdia3d) ::   trc3d   !:  additional 3d outputs  
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,    jpdia2d) ::   trc2d    !:  additional 2d outputs  
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jpdia3d) ::   trc3d    !:  additional 3d outputs  
    
-   INTEGER , PUBLIC ::   nwritedia     !: frequency of additional arrays outputs(namelist)
 # endif
 
-#if defined key_trc_diabio || defined key_trdmld_trc
-   CHARACTER(len=8),  DIMENSION(jpdiabio) ::   ctrbio   !: biological trends name      (NAMELIST)
-   CHARACTER(len=20), DIMENSION(jpdiabio) ::   ctrbiu   !: biological trends unit      (NAMELIST)
-   CHARACTER(len=80), DIMENSION(jpdiabio) ::   ctrbil   !: biological trends long name (NAMELIST)
-   INTEGER ::   nwritebio   !: time step frequency for biological outputs (NAMELIST)
+#if defined key_diabio || defined key_trdmld_trc
+   !                                                              !!*  namtop_XXX namelist *
+   INTEGER , PUBLIC                               ::   nwritebio   !: time step frequency for biological outputs 
+   CHARACTER(len=8 ), PUBLIC, DIMENSION(jpdiabio) ::   ctrbio      !: biological trends name      
+   CHARACTER(len=20), PUBLIC, DIMENSION(jpdiabio) ::   ctrbiu      !: biological trends unit   
+   CHARACTER(len=80), PUBLIC, DIMENSION(jpdiabio) ::   ctrbil      !: biological trends long name
 #endif
-# if defined key_trc_diabio
+# if defined key_diabio
    !! Biological trends
    !! -----------------
-   REAL(wp), DIMENSION(jpi,jpj,jpk,jpdiabio) :: trbio   !: biological trends
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk,jpdiabio) :: trbio   !: biological trends
 # endif
 
@@ -105,4 +105,8 @@
 #endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trc
